<template>
  <v-layout row justify-center>
    <v-dialog v-model="dialogloader" persistent width="300">
      <v-card color="#2A95BF" dark>
        <v-card-text>
          กรุณารอสักครู่
          <v-progress-linear
            indeterminate
            color="white"
            class="mb-0"
          ></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-dialog v-model="totalpaymodal" max-width="1200">
      <v-card>
        <v-toolbar dark color="#2A95BF">
          <v-btn icon dark @click="totalpaymodal = false">
            <v-icon>close</v-icon>
          </v-btn>
          <v-toolbar-title>ยืนยันรายการที่ต้องการชำระ</v-toolbar-title>
          <v-spacer></v-spacer>
        </v-toolbar>
        <v-layout align-center justify-center row wrap>
          <v-flex xs10 py-5>
            <v-data-table
              class="elevation-1"
              :headers="headers"
              :items="currenttotalpay"
              item-key="Invoice_no"
              hide-actions
            >
              <template v-slot:items="props">
                <tr style="cursor: pointer;">
                  <td class="text-xs-center">{{ props.index + 1 }}</td>
                  <td>{{ props.item.Invoice_no }}</td>
                  <td class="text-xs-right">
                    {{ props.item.invoice_description }}
                  </td>
                  <td class="text-xs-right">{{ props.item.Start_date }}</td>
                  <td class="text-xs-right">{{ props.item.Amount_Inc_VAT }}</td>
                  <td class="text-xs-right">{{ props.item.DueDate }}</td>
                </tr>
              </template>
              <template v-slot:footer>
                <td class="text-xs-right" :colspan="headers.length">
                  <br />
                  <p style="font-size: 120%;">
                    Summary Pay Amount (THB) &nbsp;&nbsp;
                    <strong>{{ totalpricepay }}</strong>
                  </p>
                </td>
              </template>
            </v-data-table>
          </v-flex>
          <v-flex xs10 text-xs-right>
            <div>
              <v-btn class="white--text" color="#2A95BF" @click="pay"
                >CONFIRM</v-btn
              >
              <br />
              <br />
            </div>
          </v-flex>
        </v-layout>
      </v-card>
    </v-dialog>
    <form ref="paymentform" name="PostForm" method="POST" :action="paymenturl">
      <input name="access_token" type="hidden" :value="paymenttoken" />
    </form>
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
export default {
  data() {
    return {
      dialogloader: false,
      notifications: false,
      sound: true,
      widgets: false,
      tempinvoices: [],
      paymenttoken: "",
      headers: [
        { text: "#", value: "index", sortable: false, align: "center" },
        {
          text: "เลขที่ Invoice",
          value: "Invoice_no",
          align: "left",
          sortable: false
        },
        {
          text: "คำอธิบาย",
          value: "invoice_description",
          align: "right",
          sortable: false
        },
        {
          text: "วันที่เริ่ม",
          value: "Start_date",
          align: "right",
          sortable: false
        },
        {
          text: "ยอด (รวมภาษี)",
          value: "Amount_Inc_VAT",
          align: "right",
          sortable: false
        },
        { text: "DueDate", value: "DueDate", align: "right", sortable: false }
      ]
    };
  },
  methods: {
    async pay() {
      try {
        this.tempinvoices = this.currenttotalpay.map(
          invoice => invoice["Invoice_no"]
        );
        this.dialogloader = true;
        let { data: info } = await this.axios.post(
          process.env.VUE_APP_APIHOST + "/createpayment",
          {
            invoiceno: this.tempinvoices,
            userid: this.$cookies.get("userid"),
            username: this.$cookies.get("username")
          }
        );
        let token = info.token;
        this.paymenttoken = token;
        console.log("temp", this.tempinvoices);
        console.log("username", this.$cookies.get("username"));
        console.log("userid", this.$cookies.get("userid"));
        console.log("paymenttk", this.paymenttoken);
        setTimeout(() => {
          this.$refs.paymentform.submit();
        }, 750);
        this.dialogloader = false;
      } catch (error) {
        this.dialogloader = false;
        console.log(error.response.data);
      }
    }
  },
  computed: {
    totalpaymodal: sync("totalpaymodal"),
    currenttotalpay: sync("currenttotalpay"),
    totalpricepay: sync("totalpricepay"),
    paymenturl() {
      return process.env.VUE_APP_PAYMENTURL;
    }
  }
};
</script>
<style></style>
